extern volatile unsigned warte_ms;
//#include "i2cmaster.c"
#include "i2c_key.h"
#include <Wire.h>

#ifndef POW_LED_ON
#define POW_LED_ON    PORT_POW_LED|=(1<<POW_LED)
#define POW_LED_OFF   PORT_POW_LED&=~(1<<POW_LED)
#define QUITT_LED_ON  PORT_QUITT_LED|=(1<<QUITT_LED)
#define QUITT_LED_OFF PORT_QUITT_LED &= ~(1<<QUITT_LED)
#define CRTL_LED_ON   PORT_CRTL_LED|=(1<<CRTL_LED)
#define CRTL_LED_OFF  PORT_CRTL_LED&=~(1<<CRTL_LED)
#endif 

boolean datenkomm=true;  //Das ist ein Mist. Keine Klassen in der Arduino IDE!
boolean read_i2c=false;  //Das ist ein Mist. Keine Klassen in der Arduino IDE!


extern volatile uint8_t key_state;  // debounced and inverted key state:
                                    // bit = 1: key pressed
extern volatile uint8_t key_press;  // key press detect
extern volatile uint8_t key_rpt;    // key long press and repeat
extern volatile uint8_t ct0, ct1, rpt;
#ifdef RTCTEST
extern volatile uint8_t sek_offset;
#endif

#define TEILER 146
unsigned char teiler=TEILER;

extern volatile unsigned char count;
extern volatile unsigned char quitt_count;

//extern volatile unsigned char long_irq;


#include "irmp.h"
#include "irmpsystem.h"


void irq_set(void)
{
  cli();          // disable global interrupts
  TCCRxA = 0;     // set CTC ?
  TCCRxA |= (1 << COMxA0);     // evtl falsch ?
  OCRxA = (F_CPU / F_INTERRUPTS) - 1;

  TCCRxB = 0;     // same for TCCR2B
  TCCRxB |= (1 << WGMx2); // set CTC 
  TCCRxB |= (1 << CSx0); // clk divider / 1 

  sei(); // enable global interrupt
}


ISR(TIMERx_COMPA_vect)                                                             // Timer1 output compare A interrupt service routine, called every 1/15000 sec
{
  uint8_t ii;
  (void) irmp_ISR();                                                        // call irmp ISR
  { if(teiler)
      teiler--;
    else
    { sei();
/*
#ifdef IRQ_TEST
      CRTL_LED_ON;
#endif
*/
      teiler=TEILER; count++;
      if(lcd_updatetime) 
        lcd_updatetime--;
      if(warte_ms)
        warte_ms--;
      if(count==1)
        ARDUINO_LED_ON;
      else  
      { if(count==21)
        ARDUINO_LED_OFF;
        if(count==100)
          count=0;
      }
/*  
      if(crtl_count)
      { CRTL_LED_ON; crtl_count--;    
      }
      else
        CRTL_LED_OFF;
*/
      if(quitt_count)
      { IR_QUITT_LED_ON; quitt_count--;    
      }
      else
        IR_QUITT_LED_OFF;
      if((test_flags&(1<<I2C_TASTATUR)) || _i2c_key )
      { //if(!_i2c_busy)
        {  
#if (ARDUINO>0)
          int _address, _data, _error; //  Wire.begin();
          if(_i2c_key=='A') _address = 0x38;
          if(_i2c_key==' ') _address = 0x20;
          Wire.beginTransmission(_address); Wire.requestFrom(_address, 1);
          #if (ARDUINO <  100)
          _data = Wire.receive();
          #else                 
          _data = Wire.read();
          #endif
          _error = Wire.endTransmission();
          if(!_error) ii = key_state ^ ~_data;
#else
          if(_i2c_key=='A')
          {  if(!i2c_start(PCF8574A_0+I2C_READ))	//;	// set device address and write mode
               ii = key_state ^ ( ( ~(unsigned char)i2c_readNak() ) ); //jar key1 kaputt		
             i2c_stop();
          }
          else
          {  if(!i2c_start(PCF8574_0+I2C_READ))	//;	// set device address and write mode
               ii = key_state ^ ( ( ~(unsigned char)i2c_readNak() ) ); //jar key1 kaputt		
             i2c_stop();
          }
#endif
          ii &= ALL_KEYS;
          ct0 = ~( ct0 & ii );                             // reset or count ct0
          ct1 = ct0 ^ (ct1 & ii);                          // reset or count ct1
          ii &= ct0 & ct1;                                 // count until roll over ?
          key_state ^= ii;                                 // then toggle debounced state
          key_press |= key_state & ii;                     // 0->1: key press detect
               
          if( (key_state & REPEAT_MASK) == 0 )            // check repeat function
            rpt = REPEAT_START;                          // start delay
          if( --rpt == 0 )
          {  rpt = REPEAT_NEXT;                            // repeat delay
             key_rpt |= key_state & REPEAT_MASK;
          }
        } // if(!_i2c_busy)
      } // if(_i2c_key)
      cli();

    } // if ! (teiler)
  } // if(!long_irq)
} // ISR (TIMER1_COMPA_vect)



